package componentesmm_v1.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class ComponentesMM_V2NavigatorContentProvider implements
		ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public ComponentesMM_V2NavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem> result = new ArrayList<componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			return result.toArray();
		}

		if (parentElement instanceof componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup) {
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup group = (componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem) {
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem navigatorItem = (componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
				.getVisualID(view)) {

		case componentesmm_v1.diagram.edit.parts.ComplexComponent2EditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Edge sv = (Edge) view;
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup target = new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup(
					componentesmm_v1.diagram.part.Messages.NavigatorGroupName_Connector_4003_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup source = new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup(
					componentesmm_v1.diagram.part.Messages.NavigatorGroupName_Connector_4003_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Node sv = (Node) view;
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup incominglinks = new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup(
					componentesmm_v1.diagram.part.Messages.NavigatorGroupName_Port_3013_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup outgoinglinks = new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup(
					componentesmm_v1.diagram.part.Messages.NavigatorGroupName_Port_3013_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortInterfaceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ProvidedInterfaceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortInterfaceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.RequiredInterfaceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup links = new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorGroup(
					componentesmm_v1.diagram.part.Messages.NavigatorGroupName_ComplexComponent_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ComplexComponent2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.SimpleComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case componentesmm_v1.diagram.edit.parts.SimpleComponentEditPart.VISUAL_ID: {
			LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem> result = new LinkedList<componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartment2EditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
							.getType(componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
				.equals(componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem> result = new ArrayList<componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new componentesmm_v1.diagram.navigator.ComponentesMM_V2NavigatorItem(
					nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem) {
			componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem abstractNavigatorItem = (componentesmm_v1.diagram.navigator.ComponentesMM_V2AbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
