package componentesmm_v1.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class ComponentesMM_V2VisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "ComponentMM_v2.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
					.equals(view.getType())) {
				return componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				componentesmm_v1.diagram.part.ComponentesMM_V2DiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
				.getComplexComponent().isSuperTypeOf(domainElement.eClass())
				&& isDiagram((componentesmm_v1.ComplexComponent) domainElement)) {
			return componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
				.getModelID(containerView);
		if (!componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getComplexComponent()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.ComplexComponent2EditPart.VISUAL_ID;
			}
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getSimpleComponent().isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.SimpleComponentEditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getComplexComponent()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID;
			}
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getSimpleComponent().isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE.getPort()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getComplexComponent()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID;
			}
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getSimpleComponent().isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE.getPort()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE.getPort()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.PortInterfaceCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getProvidedInterface().isSuperTypeOf(
							domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.ProvidedInterfaceEditPart.VISUAL_ID;
			}
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE
					.getRequiredInterface().isSuperTypeOf(
							domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.RequiredInterfaceEditPart.VISUAL_ID;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE.getPort()
					.isSuperTypeOf(domainElement.eClass())) {
				return componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
				.getModelID(containerView);
		if (!componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = componentesmm_v1.diagram.part.ComponentesMM_V2VisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case componentesmm_v1.diagram.edit.parts.ComplexComponentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ComplexComponent2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.SimpleComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponent2EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.SimpleComponentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.SimpleComponentName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.PortNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.PortInterfaceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ProvidedInterfaceEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ProvidedInterfaceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.RequiredInterfaceEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.RequiredInterfaceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentComponentCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ComplexComponent3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.SimpleComponent2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ComplexComponentPortComplexCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.PortInterfaceCompartmentEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ProvidedInterfaceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (componentesmm_v1.diagram.edit.parts.RequiredInterfaceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.SimpleComponentPortSimpleCompartment2EditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.PortEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID:
			if (componentesmm_v1.diagram.edit.parts.ConnectorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (componentesmm_v1.Componentesmm_v1Package.eINSTANCE.getConnector()
				.isSuperTypeOf(domainElement.eClass())) {
			return componentesmm_v1.diagram.edit.parts.ConnectorEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(componentesmm_v1.ComplexComponent element) {
		return true;
	}

}
